// Example debugging: window.prompt('Debug', gsAccessToken)

var gsAccessToken = "";                            
var giMessagingCheckForNew = 300;  // Better if use html5 websockets or pusher.com in the short term.
var gsBaseURL = 'https://secure.mydigitalspacelive.com';

$.ajaxSetup({
    cache: false
});

jQuery.support.cors = true;

function interfaceGadgetGetAccessToken() 
{
    var sAccessToken = System.Gadget.Settings.readString("1blankspaceAccessToken");
    if (!sAccessToken) { sAccessToken = ""; }
    return sAccessToken.toString();
}

function interfaceGadgetStart() 
{
    System.Gadget.settingsUI = "1blankspace.gadget.settings.001.html";
    System.Gadget.Flyout.file = "1blankspace.gadget.flyout.001.html";
    System.Gadget.Flyout.show = false;

    interfaceGadgetViewport();
}

function interfaceGadgetViewport() 
{

	gsAccessToken = interfaceGadgetGetAccessToken()

	$('#tdInterfaceGadgetHomeSubHeader').html('Updating...');
	
	setTimeout(function () {
		$.ajax(
		{
			type: 'POST',
			url: gsBaseURL + '/ondemand/core/?method=CORE_GET_USER_NAME&rf=JSON',
			data: 'access_token=' + encodeURIComponent(gsAccessToken),
			dataType: 'json',
			cache: false,
			async: false,
			success: function(data) 
			{
				if (data.status == 'OK' && data.firstname != undefined)
				{
					$('#tdInterfaceGadgetHomeSubHeader').html(data.firstname + ' ' + data.surname);
					$('#tdInterfaceGadgetHomeContent').html('');
					interfaceGadgetViewportHome();
				}
				else
				{
					$('#tdInterfaceGadgetHomeSubHeader').html('Invalid access token');
					$('#tdInterfaceGadgetHomeContent').html('<br />Log onto 1blankspace, click on your username and click Secure Access Token.<br /><br />' +
								'Once you have the access token, click the settings icon on the right of this gadget.');
				}	
			}
		});
	}, 750);
}

function interfaceGadgetViewportHome(aParam, oJSON) 
{
	if (oJSON == undefined)
	{
		var sParam = 'method=ACTION_SEARCH';
		var sData = 'diary=1&actionby=ME&day=0&status=2-4&rows=999';
		sData += '&access_token=' + encodeURIComponent(gsAccessToken);
		
		$.ajax(
		{
			type: 'POST',
			url: gsBaseURL + '/ondemand/action/?' + sParam,
			data: sData,
			dataType: 'json',
			success: function(data) {interfaceGadgetViewportHome(aParam, data)}
		});
	}
	else
	{
		var aHTML = [];
		var h = -1;
	
		aHTML[++h] = '<table id="tableGadgetHomeTodayActions" class="interfaceGadgetHomeTodayActions" >' +
						'<tbody>' +
							'<tr class="interfaceGadgetHeader">' +
								'<td>TODAY</td>' +
							'</tr>' +
							'<tr>' +
								'<td id="tdInterfaceGadgetHeaderTodayActions" style="font-size: 52pt; text-align:center; cursor: pointer;">'
										+ oJSON.data.rows.length + '</td>' +
							'</tr>' +
						'</tbody>' +
					'<table>';	
					
		$('#tdInterfaceGadgetHomeContent').html(aHTML.join(''))
		
		$('#tdInterfaceGadgetHeaderTodayActions').mousedown(function(event)
		{
			interfaceGadgetFlyoutShow();
		});
	}
}

function interfaceGadgetSettingsClosed(event) 
{
    if (event.closeAction == event.Action.commit) 
	{
		gsAccessToken = interfaceGadgetGetAccessToken();
		giMessagingCheckForNew = System.Gadget.Settings.readString("1blankspaceCheckForNewSeconds");
		interfaceGadgetViewport();
    }
    event.cancel = false;
}

function interfaceGadgetFlyoutShow() 
{
	System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
}

function interfaceGadgetFlyoutViewport()
{

	gsAccessToken = interfaceGadgetGetAccessToken();
	
	$.ajax(
	{
		type: 'GET',
		url: gsBaseURL + '/ondemand/core/?method=CORE_GET_USER_NAME&rf=JSON&access_token=' + encodeURIComponent(gsAccessToken),
		dataType: 'json',
		success: function(data) 
		{
			$('#divInterfaceGadgetFlyout').html('Hi, ' + data.firstname + '...');
			interfaceGadgetViewportFlyoutHome();
		}
	});
}	

function interfaceGadgetViewportFlyoutHome(aParam, oJSON) 
{
	if (oJSON == undefined)
	{
		var sParam = 'method=ACTION_SEARCH';
		var sData = 'diary=1&actionby=ME&future=1&status=2-4&rows=5&rf=JSON';
		sData += '&access_token=' + encodeURIComponent(gsAccessToken);
		
		$.ajax(
		{
			type: 'POST',
			url: gsBaseURL + '/ondemand/action/?' + sParam,
			data: sData,
			dataType: 'json',
			success: function(data) {interfaceGadgetViewportFlyoutHome(aParam, data)}
		});
	}
	else
	{
		var aHTML = [];
		var h = -1;
	
		aHTML[++h] = '<table id="tableGadgetHomeTodayActions" class="interfaceGadgetHomeTodayActions" >' +
						'<tbody>' +
							'<tr class="interfaceGadgetHeader">' +
								'<td style="font-weight:bold;font-size:12pt;">FUTURE (' + oJSON.data.rows.length + ')</td>' +
							'</tr>' +
						'</tbody>' +
					'<table>';	
					
		aHTML[++h] = '<table id="tableGadgetHomeTodayActions" class="interfaceGadgetHomeTodayActions" >' +
						'<tbody>';			
	
		$.each(oJSON.data.rows, function() 
		{ 
			
			aHTML[++h] = '<tr class="interfaceMainRow">';
				
			aHTML[++h] = '<td id="tdHomeTodayActions_subject-' + this.id + '" class="interfaceMainRow">' +
									this.subject + '</td>';
				
			var sDate = this.actiondatetime;
			sDate = sDate.replace(/&nbsp;/g, ' ')
			sDate = new Date(sDate);
			sDate = $.fullCalendar.formatDate(sDate, 'dd MMM yyyy')
			aHTML[++h] = '<td id="tdHomeTodayActions_date-' + this.id + '" class="interfaceMainRow">' +
									sDate + '</td>';
			
			var sDate = new Date(this.actiondatetime);
			
			var sDate = this.actiondatetime;
			sDate = sDate.replace(/&nbsp;/g, ' ')
			sDate = new Date(sDate);
			
			if ($.fullCalendar.formatDate(sDate, 'H') != '0' || $.fullCalendar.formatDate(sDate, 'm') != '0')
			{
				sDate = $.fullCalendar.formatDate(sDate, 'h:mm TT')
			}
			else
			{
				sDate = '&nbsp;';
			}	
									
			aHTML[++h] = '<td id="tdHomeTodayActions_time-' + this.id + '" class="interfaceMainRow">' +
									sDate + '</td>';
									
			aHTML[++h] = '<td id="tdHomeTodayActions_contact-' + this.contactperson + '" class="interfaceMainRow interfaceContact">' +
									this.contactpersonfirstname + ' ' + 
									this.contactpersonsurname + '</td>';
			
			aHTML[++h] = '<td id="tdHomeTodayActions-' + this.id + '" class="interfaceMainRow" style="width:65px;">';
			
			aHTML[++h] = '</td></tr>';
	
		});
			
		aHTML[++h] = '</tbody>' +
						'<table>';	
			
		$('#divInterfaceGadgetFlyoutHome').html(aHTML.join(''))
		
		$('#tdInterfaceGadgetHeaderTodayActions').mousedown(function(event)
		{
			interfaceGadgetFlyoutShow();
		});
	}
}


